

	function random_ore()
		local n = love.math.random(100)
		if n<46 then return {"iron","raw"}
		elseif n<91 then return {"copper","raw"}
		elseif n<95 then return {"tin","bar"}
		elseif n<99 then return {"bronze","bar"}
		elseif n==99 then return {"R_iron","bar"}
		else return {"R_copper","bar"} end
	end

function random_cart()
	local n = love.math.random(14)
	if n<6 then add_cart(1,love.math.random(10))
	elseif n<11 then add_cart(2,love.math.random(10))
	elseif n==11 then add_cart(3,1)
	elseif n==12 then add_cart(4,1)
	elseif n==13 then add_cart(5,love.math.random(2))
		else add_cart(6,love.math.random(2))
		end

end

cart_q={}

function ore_lookup(n)
	local o={"iron","copper","R_iron","R_copper","bronze","tin"}
	return o[n]
end

function next_ore()
	if cart_q[1][2]==0 then 
		table.remove(cart_q,1)
		return false
	else 
		cart_q[1][2]= cart_q[1][2] -1
		return true, cart_q[1][3] end
end

function add_cart(ore_id,amount)
	if ore_id>2 then a ="bar" else a = "raw" end
	table.insert(cart_q,{ore_id,amount,{ore_lookup(ore_id),a}})
end

cart_q={}
for i=1,3 do
	random_cart()
end

function pokebox(x,y,with)
	function f(a,b) if (a > 0 and a < b+1) then return true else return false end end
	if f(x,gridsize.x) and f(y,gridsize.y) then
		if grid[x][y][2] == "none" then
			exists,next=next_ore()
			
			if exists then 
				grid[x][y]=next
				combinecheck(x,y,grid[x][y][2])
				--next=random_ore()
			end
		end
	end 
end

combo_his= {"nothing + nothings = nothing","nothing + nothings = nothing","nothing + nothings = nothing","nothing + nothings = nothing","nothing + nothings = nothing"}

function combinecheck(x,y,tier)

	--print(tier)

	local function historyupdate(combo_table,out)

		local function string_gen(t,o)
			s_out = nil
			local function ss(s)
				if s_out == nil then s_out = s
				else s_out = s_out .. " + " .. s end
			end
			for k, v in pairs(t) do
				--print(s_out)
      			if v == 0 then
      			elseif v==1 then ss(k)
      			else ss(v.."x "..k) end
    		end
    		s_out = s_out .. " = " .. o 
    		return s_out
		end

		local function assignmentjank(s)
			combo_his[1],combo_his[2],combo_his[3],combo_his[4],combo_his[5]
			=
			s           ,combo_his[1],combo_his[2],combo_his[3],combo_his[4]
		end
		
		assignmentjank(string_gen(combo_table,out))

	end
	
	function clean_table(tier)
		if tier == "raw" then return {iron=0,copper=0} end
		if tier == "trash" then return{trash=0} end
		if tier == "bar" then return {R_iron=0,R_copper=0,mixed=0,bronze=0,tin=0}end
		if tier == "heavy" then return {P_iron=0,P_copper=0,obsid=0} end
		if tier == "fancy" then return {gold=0,silver=0,F_gold=0,steel=0,damas=0,meteor=0} end
		if tier == "end" then return "error" end
	end

	local combine_table = clean_table(tier)

	function touchingcheck(xx,yy,f)
		if grid[xx][yy][2]==tier and tier ~= "end" then
			f(xx,yy)
			--------
			if (not (x == xx+1 and y== yy  ) and grid[xx+1][yy  ][2]==tier) then f(xx+1,yy  ) end
			if (not (x == xx-1 and y== yy  ) and grid[xx-1][yy  ][2]==tier) then f(xx-1,yy  ) end
			if (not (x == xx   and y== yy+1) and grid[xx  ][yy+1][2]==tier) then f(xx  ,yy+1) end
			if (not (x == xx   and y== yy-1) and grid[xx  ][yy-1][2]==tier) then f(xx  ,yy-1) end
		end
	end

	touchingcount = 0
	function count(xx,yy)
		touchingcount = touchingcount + 1
	end

	local combine_pos = 2

	function zero(xx,yy)
		type=grid[xx][yy][1]
		combine_table[type]=combine_table[type] + 1
		grid[xx][yy]= {"error","none"}
	end


	touchingcheck(x+1,y  ,count)
	touchingcheck(x-1,y  ,count)
	touchingcheck(x  ,y+1,count)
	touchingcheck(x  ,y-1,count)
	
	--print(touchingcount)
	------

	if (touchingcount >= 2) then

		touchingcheck(x+1,y  ,zero)
		touchingcheck(x-1,y  ,zero)
		touchingcheck(x  ,y+1,zero)
		touchingcheck(x  ,y-1,zero)

		zero(x,y)

		--combine_table = table.sort(combine_table)

		function tier_matcher(tier)
			if tier == "raw" then return raw_matcher(combine_table) end
			if tier == "bar" then return bar_matcher(combine_table) end
			if tier == "heavy" then return heavy_matcher(combine_table) end
			if tier == "fancy" then return fancy_matcher(combine_table) end
			if tier == "trash" then return trash_matcher(combine_table) end
			if tier == "end" then return "error" end
		end
		--print(tier,combine_table)
		out = tier_matcher(tier)
		grid[x][y]= out
		historyupdate(combine_table,out[1])
		--print(grid[x][y][1])
		--print(grid[x][y][2])
		--print(combine_table["iron"])
		combinecheck(x,y,grid[x][y][2])
	end
end


function score()
	local count={iron=0,copper=0,trash=0,P_iron=0,P_copper=0,obsid=0,
				R_iron=0,R_copper=0,mixed=0,bronze=0,tin=0,gold=0,
				silver=0,F_gold=0,steel=0,damas=0,meteor=0,myth=0,
				W_gold=0,etherial=0,D_steel=0,     error=0}


	for i=1,gridsize.x do
		for j=1,gridsize.y do
			local name= grid[i][j][1]
			count[name]=count[name]+1
		end
	end

	local score = 0

	local function add(x)
		score = score + x
	end

	if count["myth"]>1 then add(3000) end
	if count["W_gold"]>1 then add(3000) end
	if count["etherial"]>1 then add(3000) end
	if count["D_steel"]>1 then add(3000) end

	local function e(name)
		if count[name] > 0 then return true else return false end
	end

	if e("myth") and e("W_gold") and e("etherial") and e("D_steel") then add(10000) end

	add(  (count["myth"]+count["W_gold"]+count["etherial"]+count["D_steel"])*500  )

	add(  (count["gold"]*3+count["silver"]+count["F_gold"]*.5)*100   )

	add(  (count["steel"]+count["damas"]*2)*70   )

	add(  (count["meteor"]*2+count["obsid"])*45  )

	add(  (count["P_iron"]+count["P_copper"])*50 )

	add(  (count["R_iron"]+count["R_copper"]+count["mixed"]*2)*20    )

	add(  (count["bronze"]+count["tin"])*5       )

	add(  (count["iron"]+count["copper"]  -  count["trash"])*1         )

	return score
end











---------------


function love.load()
    grid = {}
    gridsize = {x=8,y=7}
    for i=0,gridsize.x+1 do
    	grid[i]={}
    	for j=0,gridsize.y+1 do  -- todo? make proper edge checking?
    		grid[i][j]={"error","none"}
    	end
    end
    boxsize = {x=130,y=130}
    love.filesystem.load("ore_combo.lua")()
    love.filesystem.load("draw_functions.lua")()
    love.window.setFullscreen(true, "desktop")
end
 
ticks=0
function love.update(dt)
	ticks=ticks + dt

	if ticks > 6 then
		ticks = ticks -6
		random_cart()
		while #cart_q >8 do
			pokebox(love.math.random(gridsize.x),love.math.random(gridsize.y))
		end
	end

end

function love.mousepressed(x, y, button, istouch)
 -- Versions prior to 0.10.0 use the MouseConstant 'l'
      pokebox(
      	math.ceil(x/boxsize.x),
      	math.ceil(y/boxsize.y),
      	button)
    if #cart_q ==1 then
		random_cart()
	end
end

function love.keypressed(key,a,b)
	--[[if key=="1" then
		for i=1,100 do
			pokebox(love.math.random(gridsize.x),love.math.random(gridsize.y))
		end
	end]]
end



-------


function num(x)
	if x then return 1 else return 0 end
end

function drawbox(x,y)
	local tier=grid[x][y][2]
	if not (tier == "none") then 
		draw_ore((x-1)*boxsize.x,(y-1)*boxsize.y,grid[x][y][1]) end
	--[[love.graphics.setColor(
		num(tier == 0),
		num(tier == 1),
		num(tier == 2))]]
	love.graphics.print(grid[x][y][1],(x-1)*boxsize.x+12,(y-1)*boxsize.y,1)
end


 

function love.draw()
	--- draw grid
	love.graphics.setColor(1,1,1)
	for i=0,gridsize.x do
		love.graphics.line(i*boxsize.x,0,i*boxsize.x,gridsize.y*boxsize.y)
	end
	for i=0,gridsize.y do
		love.graphics.line(0,i*boxsize.y,gridsize.x*boxsize.x,i*boxsize.y)
	end

	--draw_ore(0,0,"iron")
--- draw boxes
	for i=1,gridsize.x do
		for j=1,gridsize.y do
			drawbox(i,j)
		end

	end

	draw_ore(1600,64,cart_q[1][3][1])
	love.graphics.print("score: "..score(), 1600,200,0,3,3)
	love.graphics.print(combo_his[1], 1400,250,0,2,2)
	love.graphics.print(combo_his[2], 1400,280,0,2,2)
	love.graphics.print(combo_his[3], 1400,310,0,2,2)
	love.graphics.print(combo_his[4], 1400,340,0,2,2)
	love.graphics.print(combo_his[5], 1400,370,0,2,2)

	for i=1,#cart_q do
		draw_cart(1200,i*150,cart_q[i][1])
	end
	love.graphics.print("x"..cart_q[1][2],1700,130,0,5,5)
	if #cart_q>5 then
		love.graphics.setColor(1,0,0)
		love.graphics.print("warning, don't stack 7 carts",1000,100,3.14/6,2,2)
	end
end